package exnihilocreatio.blocks;

import exnihilocreatio.ExNihiloCreatio;
import exnihilocreatio.compatibility.ITOPInfoProvider;
import exnihilocreatio.tiles.TileStoneAxle;
import mcjty.theoneprobe.api.IProbeHitData;
import mcjty.theoneprobe.api.IProbeInfo;
import mcjty.theoneprobe.api.ProbeMode;
import net.minecraft.block.ITileEntityProvider;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.IProperty;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.AxisAlignedBB;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.text.TextFormatting;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class BlockStoneAxle extends BlockBase implements ITileEntityProvider, ITOPInfoProvider {
    public static final IProperty<Boolean> IS_AXLE = PropertyBool.func_177716_a("is_axle");
    private static final AxisAlignedBB hitboxEW = new AxisAlignedBB(0, 0, 0, 1, .5, .5).func_72317_d(0, 0.25, 0.25);
    private static final AxisAlignedBB hitboxSN = new AxisAlignedBB(0, 0, 0, .5, .5, 1).func_72317_d(0.25, 0.25, 0);


    public BlockStoneAxle() {
        super(Material.field_151576_e, "block_axle_stone");
        func_149647_a(ExNihiloCreatio.tabExNihilo);
        func_149711_c(2);
        setHarvestLevel("pickaxe", 0);

        func_180632_j(field_176227_L.func_177621_b().func_177226_a(IS_AXLE, false));
    }

    @Nullable
    @Override
    public TileEntity func_149915_a(@Nonnull World worldIn, int meta) {
        return new TileStoneAxle();
    }

    @Override
    @Nonnull
    public IBlockState func_176221_a(@Nonnull IBlockState state, IBlockAccess worldIn, BlockPos pos) {
        return state.func_177226_a(IS_AXLE, false);
    }

    @Override
    @Nonnull
    protected BlockStateContainer func_180661_e() {
        return new BlockStateContainer(this, IS_AXLE);
    }

    @Override
    @Nonnull
    public IBlockState func_176203_a(int meta) {
        return func_176223_P();
    }

    @Override
    public int func_176201_c(IBlockState state) {
        return 0;
    }

    @Override
    public boolean func_176225_a(IBlockState blockState, @Nonnull IBlockAccess blockAccess, @Nonnull BlockPos pos, EnumFacing side) {
        return false;
    }

    @Override
    public boolean func_149637_q(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_149662_c(IBlockState state) {
        return false;
    }

    private TileStoneAxle getTe(IBlockAccess world, BlockPos pos) {
        return (TileStoneAxle) world.func_175625_s(pos);
    }

    @Override
    public void func_180633_a(World worldIn, BlockPos pos, IBlockState state, EntityLivingBase placer, ItemStack stack) {
        TileStoneAxle te = getTe(worldIn, pos);
        te.facing = placer.func_174811_aO();
    }

    @Override
    public boolean func_149730_j(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_149721_r(IBlockState state) {
        return false;
    }

    @Override
    public boolean func_149686_d(IBlockState state) {
        return false;
    }

    @Nullable
    @Override
    public AxisAlignedBB func_180646_a(IBlockState blockState, @Nonnull IBlockAccess worldIn, @Nonnull BlockPos pos) {
        TileEntity te = worldIn.func_175625_s(pos);
        if (te != null && te instanceof TileStoneAxle) {
            switch (((TileStoneAxle) te).facing) {

                case DOWN:
                case UP:
                case NORTH:
                case SOUTH:
                    return hitboxSN;
                case WEST:
                case EAST:
                    return hitboxEW;
            }
        }
        return field_185505_j;
    }

    @Override
    @Nonnull
    public AxisAlignedBB func_185496_a(IBlockState state, IBlockAccess source, BlockPos pos) {
        TileEntity te = source.func_175625_s(pos);
        if (te != null && te instanceof TileStoneAxle) {
            switch (((TileStoneAxle) te).facing) {

                case DOWN:
                case UP:
                case NORTH:
                case SOUTH:
                    return hitboxSN;
                case WEST:
                case EAST:
                    return hitboxEW;
            }
        }
        return field_185505_j;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void addProbeInfo(ProbeMode mode, IProbeInfo probeInfo, EntityPlayer player, World world, IBlockState blockState, IProbeHitData data) {

        TileStoneAxle axle = (TileStoneAxle) world.func_175625_s(data.getPos());
        if (axle == null)
            return;

        probeInfo.text("Effective Rotation: " + axle.getEffectivePerTickRotation(axle.facing));

        if (mode == ProbeMode.EXTENDED) {
            probeInfo.text(TextFormatting.BLUE + "Own Rotation: " + axle.getOwnRotation());
            probeInfo.text(TextFormatting.BLUE + "Facing: " + axle.facing.func_176610_l());
        }

    }
}
