package exnihilocreatio.util;

import lombok.Getter;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityList;
import net.minecraft.entity.EntityLiving;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.EnumDifficulty;
import net.minecraft.world.World;

public class EntityInfo {
    @Getter
    private Class <? extends Entity > entityClass;

    @Getter
    private String name;

    public EntityInfo(String entityName){
        this.name = entityName;
        this.entityClass = entityName == null ? null : EntityList.getClass(new ResourceLocation(entityName));
    }

    /**
     * Attempts to spawn entity located  within `range` of `pos`
     * @param pos
     * @param range
     * @param worldIn
     * @return whether it did spawn the mob
     */
    public boolean spawnEntityNear(BlockPos pos, int range, World worldIn){
        if (entityClass == null || name == null)
            return false;

        if(!worldIn.field_72995_K && worldIn.func_175659_aa() != EnumDifficulty.PEACEFUL){
            Entity entity = EntityList.func_191304_a(entityClass, worldIn);
            if(entity instanceof EntityLiving){
                EntityLiving entityLiving = (EntityLiving) entity;

                double dx = (worldIn.field_73012_v.nextDouble() - worldIn.field_73012_v.nextDouble())*range + 0.5;
                double dy = (worldIn.field_73012_v.nextDouble() - worldIn.field_73012_v.nextDouble())*range;
                double dz = (worldIn.field_73012_v.nextDouble() - worldIn.field_73012_v.nextDouble())*range + 0.5;
                BlockPos spawnPos = new BlockPos(pos.func_177958_n()+dx, pos.func_177956_o()+dy, pos.func_177952_p()+dz);

                entityLiving.func_70107_b(spawnPos.func_177958_n(), spawnPos.func_177956_o(), spawnPos.func_177952_p());

                boolean canSpawn = worldIn.func_184144_a(entityLiving, entityLiving.func_174813_aQ()).isEmpty();
                if(canSpawn) {
                    worldIn.func_72838_d(entityLiving);
                    worldIn.func_175718_b(2004, pos, 0);
                    entityLiving.func_70656_aK();
                    return true;
                }
                else{
                    return false;
                }
            }
            return false; // Not a Living Entity, not currently handled.
        }

        return false;
    }

    public static EntityInfo EMPTY = new EntityInfo(null);
}
